<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fmp="http://www.filemaker.com/fmpxmlresult">


<!-- mailing-ndl.xsl		 (Notes de lecture, version 2.0 - janvier 2016)

Transforme les donnees exportéees de notes.fp5 en fichier texte au format csv, avec :

- encodage des caracteres : selon parametres en entree (cf. $wichEncoding)
- dans les champs Notes et citations les caracteres tab/eol sont remplaces par des chaines passees en parametres, 
  ils sont inhibes dans tous les autres champs (remplaces par 1 espace)
- ajout d'une 1e ligne avec le nom des colonnes

Ordre des data en entree : 
RefBiblio, Fichier, CodeLIV, CodeART, ART AutPrenom, ART AutNom, ART Titre, ART Date, ART Pages, ART Url, ART Categ, ART MotsCles, ART NotesSuppl, ART AjouterURLlivre, ART SansGuillemet, TypeDeRef, LIV AutNom, LIV AutPrenom, LIV AutSecond, LIV Titre, LIV VOLnum, LIV VOLtitre, LIV an1eParu, LIV url, LIV pages, LIV support, LIV EDcoll, LIV EDan, LIV EDperiod, LIV EDediteur, LIV EDlieu, LIV EDserie, LIV EstPeriodiq, LIV MentionDir, LIV MentionEdit, LIV TypeMemoire, LIV NotesSupplem, LIV Categ, LIV MotsCles, NOTE citations, NOTE notes, NOTE modifLe, NOTE obs, jeTeVeux, NDL 1.6 personnalisée • dév en cours


Tous les champs sont conserves


-->


<!--  Constantes -->
<xsl:variable name="cr"> <xsl:text>&#13;</xsl:text> </xsl:variable>
<xsl:variable name="lf"> <xsl:text>&#10;</xsl:text> </xsl:variable>
<xsl:variable name="wineol"> <xsl:text>&#13;&#10;</xsl:text> </xsl:variable>
<xsl:variable name="FMeol_in"> <xsl:text>&#10;</xsl:text> </xsl:variable>
<xsl:param name="tab"> <xsl:text>&#9;</xsl:text> </xsl:param>
<xsl:variable name="guill"> <xsl:text>"</xsl:text> </xsl:variable>
<xsl:variable name="guill_out"> <xsl:text>'</xsl:text> </xsl:variable>

<!--		PARAMETRES importes : chaine extraite du dernier champ du 1er record
		structure de la chaine : param wichEncoding[prm1]param FMtab_out[prmTAB]param FMeol_out[prmEOL]

		Note : wichEncoding est pour l'instant inutile puisque fixé par stylesSheet appelante 
		mais prevu au cas ou je trouverais une solution pour parametrer l'attribut encoding de <xsl:stylesheet>
-->
<xsl:variable name="params"> <xsl:value-of select="fmp:FMPXMLRESULT/fmp:RESULTSET/fmp:ROW[1]/fmp:COL[last()]"/> </xsl:variable>
<xsl:param name="FMtab_out"><xsl:value-of select="substring-before(substring-after($params,'[prm1]'), '[prmTAB]')"/></xsl:param>
<xsl:param name="FMeol_out"><xsl:value-of select="substring-before(substring-after($params,'[prmTAB]'), '[prmEOL]')"/></xsl:param>

<!-- Separateurs d'enregistrement et de champ -->
<xsl:param name="newrecord">
	<xsl:call-template name="recordSeparator">
	<xsl:with-param name="encoding" select ="$wichEncoding" />
	</xsl:call-template>
</xsl:param>
 <xsl:param name="newfield"> <xsl:text>;</xsl:text> </xsl:param>


<!--  main template -->
<xsl:template match="fmp:FMPXMLRESULT">

	<!-- nom colonnes en en-tete -->
	<xsl:value-of select="concat('RefBiblio', $newfield, 'Objet', $newfield, 'CodeLIV', $newfield, 'CodeART', 
			$newfield, 'ART AutPrenom', $newfield, 'ART AutNom', $newfield, 'ART Titre', $newfield, 'ART Date', $newfield, 'ART Pages', $newfield, 'ART Descrip_Electroniq', $newfield, 'ART Categ', $newfield, 'ART MotsCles', $newfield, 'ART NotesSuppl', $newfield, 'ART AjouterURLlivre', $newfield, 'ART SansGuillemet', $newfield, 'ART dateModif', 
			$newfield, 'LIV TypeDeRef', $newfield, 'LIV AutNom', $newfield, 'LIV AutPrenom', $newfield, 'LIV AutSecond', $newfield, 'LIV Titre', $newfield, 'LIV VOLnum', $newfield, 'LIV VOLtitre', $newfield, 'LIV an1eParu', $newfield, 'LIV Descrip_Electroniq', $newfield, 'LIV descrip_Imprime', $newfield, 'LIV support', $newfield, 'LIV EDan', $newfield, 'LIV EDperiod', $newfield, 'LIV EDediteur', $newfield, 'LIV EDlieu', $newfield, 'LIV EDcoll', $newfield, 'LIV EDserie', $newfield, 'LIV EstPeriodiq', $newfield, 'LIV MentionDir', $newfield, 'LIV MentionEdit', $newfield, 'LIV TypeMemoire', $newfield, 'LIV NotesSupplem', $newfield, 'LIV Categ', $newfield, 'LIV MotsCles', $newfield, 'LIV obsPratiq', $newfield, 'LIV dateModif', $newfield, 'NOTE citations', $newfield, 'NOTE notes', $newfield, 'NOTE obsPratiq', $newfield, 'NOTE dateModif', 
			$newfield, 'jeTeVeux', $newfield, 'idnum_LIV', $newfield, 'idnum_ART', $newfield, 'idnum_NOT')" />
	<xsl:value-of select="$newrecord" />

	<!-- data -->
	<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[1]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[2]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[3]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[4]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[5]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[6]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[7]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[8]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[9]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[10]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[11]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[12]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[13]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[14]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[15]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[16]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[17]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[18]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[19]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[20]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[21]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[22]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[23]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[24]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[25]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[26]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[27]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[28]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[29]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[30]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[31]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[32]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[33]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[34]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[35]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[36]" /> </xsl:call-template>
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[37]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[38]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[39]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[40]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<!-- Liv obs pratiq : --> <xsl:call-template name="replace_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[41]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="del_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[42]" /> </xsl:call-template>
		<!-- Note : champs avec retours : not, cit, obs pratiq -->
		<xsl:value-of select="$newfield" />
		<xsl:call-template name="replace_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[43]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="replace_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[44]" /> </xsl:call-template>
		<xsl:value-of select="$newfield"/>
		<xsl:call-template name="replace_tabAndEol"> <xsl:with-param name="str" select ="fmp:COL[45]" /> </xsl:call-template>
		<!-- date note-->
		<xsl:value-of select="$newfield" /> <xsl:value-of select="fmp:COL[46]" />
		<!-- JeTeVeux (commun), idnum L, idnum A, idnum N -->
		<xsl:value-of select="$newfield" /> <xsl:value-of select="fmp:COL[47]" />
		<xsl:value-of select="$newfield" /> <xsl:value-of select="fmp:COL[48]" />
		<xsl:value-of select="$newfield" /> <xsl:value-of select="fmp:COL[49]" />
		<xsl:value-of select="$newfield" /> <xsl:value-of select="fmp:COL[50]" />

		<xsl:value-of select="$newrecord" />
	</xsl:for-each>
</xsl:template>


<xsl:template name="recordSeparator">
<xsl:param name="encoding"/>
	<xsl:choose>
		<xsl:when test="$encoding=1"><xsl:value-of select="$cr"/></xsl:when>
		<xsl:when test="$encoding=2"><xsl:value-of select="$wineol"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="$lf"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- Remplace les cars separateurs par ceux passes en parametre -->
<xsl:template name="replace_tabAndEol">
<xsl:param name="str"/>
	<xsl:variable name="tmp">
		<xsl:call-template name="replaceString">
			<xsl:with-param name="str" select ="$str"/>
			<xsl:with-param name="from" select ="$guill"/>
			<xsl:with-param name="to" select ="$guill_out"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="tmp1">
		<xsl:call-template name="replaceString">
			<xsl:with-param name="str" select ="$tmp"/>
			<xsl:with-param name="from" select ="$FMeol_in"/>
			<xsl:with-param name="to" select ="$FMeol_out"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:value-of select="$guill"/>
	<xsl:call-template name="replaceString">
		<xsl:with-param name="str" select ="$tmp1"/>
		<xsl:with-param name="from" select ="$tab"/>
		<xsl:with-param name="to" select ="$FMtab_out"/>
	</xsl:call-template>
	<xsl:value-of select="$guill"/>
</xsl:template>

<!-- inhibe les cars separateurs (remplaces par un espace) -->
<xsl:template name="del_tabAndEol">
<xsl:param name="str"/>
	<xsl:variable name="tmp">
		<xsl:call-template name="replaceString">
			<xsl:with-param name="str" select ="$str"/>
			<xsl:with-param name="from" select ="$guill"/>
			<xsl:with-param name="to" select ="$guill_out"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="tmp1">
		<xsl:call-template name="replaceString">
			<xsl:with-param name="str" select ="$tmp"/>
			<xsl:with-param name="from" select ="$FMeol_in"/>
			<xsl:with-param name="to" select ="' '"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:value-of select="$guill"/>
	<xsl:call-template name="replaceString">
		<xsl:with-param name="str" select ="$tmp1"/>
		<xsl:with-param name="from" select ="$tab"/>
		<xsl:with-param name="to" select ="' '"/>
	</xsl:call-template>
	<xsl:value-of select="$guill"/>
</xsl:template>

<!-- ****************** UTILITAIRES ****************** -->

<!--	 	replaceString $str, $from, $to
		rech/remplacement simple dans une chaine (recursif)
-->
<xsl:template name="replaceString">
	<xsl:param name="str"/>
	<xsl:param name="from"/>
	<xsl:param name="to"/>
	<xsl:choose>
		<xsl:when test="contains($str,$from)">
			<xsl:value-of select="substring-before($str,$from)"/>
			<xsl:value-of select="$to"/>
			<xsl:call-template name="replaceString">
				<xsl:with-param name="str" select ="substring-after($str,$from)"/>
				<xsl:with-param name="from" select ="$from"/>
				<xsl:with-param name="to" select ="$to"/>
			</xsl:call-template>
		 </xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$str"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
