<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fmp="http://www.filemaker.com/fmpxmlresult">

<!--		tab-biblio.xsl	(Notes de lecture, version 1.6 - novembre 2007)

		Transforme les donnees exportees de la table "biblios" en fichier texte au format tabulations

		champs a exporter : en fonction de la valeur du dernier champ
-->


<!--  constantes -->
<xsl:variable name="cr"> <xsl:text>&#13;</xsl:text> </xsl:variable>
<xsl:variable name="lf"> <xsl:text>&#10;</xsl:text> </xsl:variable>
<xsl:variable name="wineol"> <xsl:text>&#13;&#10;</xsl:text> </xsl:variable>
<xsl:variable name="FMeol_in"> <xsl:text>&#10;</xsl:text> </xsl:variable>
<xsl:variable name="FMeol_out"> <xsl:text> </xsl:text> </xsl:variable>
<xsl:variable name="FMtab_out"> <xsl:text> </xsl:text> </xsl:variable>

<!-- Separateurs d'enregistrement et de champ -->
<xsl:param name="newrecord">
	<xsl:call-template name="recordSeparator">
	<xsl:with-param name="encoding" select ="$wichEncoding" />
	</xsl:call-template>
</xsl:param>
<xsl:param name="newfield"> <xsl:text>&#9;</xsl:text> </xsl:param>

<!--		PARAMETRE importe : dernier champ du 1er record -->
<xsl:variable name="wichFields"> <xsl:value-of select="fmp:FMPXMLRESULT/fmp:RESULTSET/fmp:ROW[1]/fmp:COL[last()]"/> </xsl:variable>


<!--  main template -->
<xsl:template match="fmp:FMPXMLRESULT">
	<xsl:choose>
		<xsl:when test="$wichFields=0">
		<!-- biblio seule -->
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="refbib" />
				<xsl:value-of select="$newrecord"/>
			</xsl:for-each>
		</xsl:when>
		<xsl:when test="$wichFields=1">
		<!-- categ, biblio -->
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="categ" />
				<xsl:value-of select="$newfield"/>
				<xsl:call-template name="refbib" />
				<xsl:value-of select="$newrecord"/>
			</xsl:for-each>
		</xsl:when>
		<xsl:when test="$wichFields=2">
		<!-- codeL, codeA, biblio -->
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="codes" />
				<xsl:value-of select="$newfield"/>
				<xsl:call-template name="refbib" />
				<xsl:value-of select="$newrecord"/>
			</xsl:for-each>
		</xsl:when>
		<xsl:when test="$wichFields=3">
		<!-- codeL, codeA, categ, biblio -->
			<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
				<xsl:call-template name="codes" />
				<xsl:value-of select="$newfield"/>
				<xsl:call-template name="categ" />
				<xsl:value-of select="$newfield"/>
				<xsl:call-template name="refbib" />
				<xsl:value-of select="$newrecord"/>
			</xsl:for-each>
		</xsl:when>
		<xsl:otherwise>
			<xsl:text>Export incorrect : parametre [wichFields] manquant</xsl:text>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>


<xsl:template name="recordSeparator">
<xsl:param name="encoding"/>
	<xsl:choose>
		<xsl:when test="$encoding=1"><xsl:value-of select="$cr"/></xsl:when>
		<xsl:when test="$encoding=2"><xsl:value-of select="$wineol"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="$lf"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="codes">
	<xsl:call-template name="replaceTabAndNewLine">
		<xsl:with-param name="str" select ="fmp:COL[1]" />
	</xsl:call-template>
	<xsl:value-of select="$newfield"/>
	<xsl:call-template name="replaceTabAndNewLine">
		<xsl:with-param name="str" select ="fmp:COL[2]" />
	</xsl:call-template>
</xsl:template>

<xsl:template name="categ">
	<xsl:call-template name="replaceTabAndNewLine">
		<xsl:with-param name="str" select ="fmp:COL[3]" />
	</xsl:call-template>
</xsl:template>

<xsl:template name="refbib">
	<xsl:call-template name="replaceTabAndNewLine">
		<xsl:with-param name="str" select ="fmp:COL[4]" />
	</xsl:call-template>
</xsl:template>

<!-- ****************** UTILITAIRES ****************** -->

<!-- replaceOpenAndCloseTags $str, $from, $to, $from2, $to2
		rech/remplacement d'un couple de chaine dans un paragraphe :		pour traitement des balises entourant passages a formater
-->
<xsl:template name="replaceTabAndNewLine">
<xsl:param name="str"/>
	<xsl:variable name="tmp">
		<xsl:call-template name="replaceString">
			<xsl:with-param name="str" select ="$str"/>
			<xsl:with-param name="from" select ="$FMeol_in"/>
			<xsl:with-param name="to" select ="$FMeol_out"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:call-template name="replaceString">
		<xsl:with-param name="str" select ="$tmp"/>
		<xsl:with-param name="from" select ="$newfield"/>
		<xsl:with-param name="to" select ="$FMtab_out"/>
	</xsl:call-template>
</xsl:template>

<!--	 	replaceString $str, $from, $to
		rech/remplacement simple dans une chaine (recursif)
-->
<xsl:template name="replaceString">
	<xsl:param name="str"/>
	<xsl:param name="from"/>
	<xsl:param name="to"/>
	<xsl:choose>
		<xsl:when test="contains($str,$from)">
			<xsl:value-of select="substring-before($str,$from)"/>
			<xsl:value-of select="$to"/>
			<xsl:call-template name="replaceString">
				<xsl:with-param name="str" select ="substring-after($str,$from)"/>
				<xsl:with-param name="from" select ="$from"/>
				<xsl:with-param name="to" select ="$to"/>
			</xsl:call-template>
		 </xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="$str"/>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
