<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fmp="http://www.filemaker.com/fmpxmlresult" exclude-result-prefixes="fmp">
<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

<!--	
	ndl-xml-minimal.xsl		(Notes de lecture, version 1.6 - novembre 2007)
	===========
 	Transforme les donnees exportees de la table "Update" en xml simple, sans DTD

	Aucun parametrage : tous les champs sont conserves et on ne gere pas les italiq
-->


<!-- surtout pas !
<xsl:strip-space elements="*" />
-->


<!-- constantes	-->
<xsl:variable name="cr"> <xsl:text>&#13;</xsl:text> </xsl:variable>
<xsl:variable name="lf"> <xsl:text>&#10;</xsl:text> </xsl:variable>

<xsl:variable name="cr_only"><xsl:text>&#10;</xsl:text></xsl:variable>
<xsl:variable name="cr_indent"><xsl:text>&#10;&#9;&#9;</xsl:text></xsl:variable>

<!--  extraction nom table et version NDL -->
<xsl:variable name="newfield"> <xsl:text>&#9;</xsl:text> </xsl:variable>
<xsl:variable name="newrecord"> <xsl:value-of select="$lf"/> </xsl:variable>


<xsl:variable name="NDLversion"> <xsl:value-of select="fmp:FMPXMLRESULT/fmp:RESULTSET/fmp:ROW[1]/fmp:COL[45]" /> </xsl:variable>
<xsl:variable name="tmp"> <xsl:value-of select="fmp:FMPXMLRESULT/fmp:RESULTSET/fmp:ROW[1]/fmp:COL[2]" /> </xsl:variable>
<xsl:variable name="NDLtable"> <xsl:value-of select="translate($tmp,'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')" /> </xsl:variable>

<!-- main template	-->
<xsl:template match="fmp:FMPXMLRESULT">

<!--
	<xsl:call-template name="insertTag">
		<xsl:with-param name="tag" select ="'ndl'"/> <xsl:with-param name="mustClose" select ="0"/>
	</xsl:call-template>
-->
	<xsl:call-template name="openTagWithAttribute">
		<xsl:with-param name="tag" select ="'ndl'"/>
			<xsl:with-param name="attribName" select ="'version'"/><xsl:with-param name="attribValue" select ="$NDLversion"/>
	</xsl:call-template>

	<!-- fiches -->
	<xsl:for-each select="fmp:RESULTSET/fmp:ROW">
		<!-- ouvre balise de table -->
		<xsl:value-of select="$cr_only"/>
		<xsl:text>	</xsl:text>
		<xsl:call-template name="insertTag">
			<xsl:with-param name="tag" select ="$NDLtable"/> <xsl:with-param name="mustClose" select ="0"/>
		</xsl:call-template>

		<!-- champs -->
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'RefBiblio'"/> <xsl:with-param name="fieldpos" select ="1"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'Objet'"/> <xsl:with-param name="fieldpos" select ="2"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'CodeLIV'"/> <xsl:with-param name="fieldpos" select ="3"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'CodeART'"/> <xsl:with-param name="fieldpos" select ="4"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTautPrenom'"/> <xsl:with-param name="fieldpos" select ="5"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTautNom'"/> <xsl:with-param name="fieldpos" select ="6"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTtitre'"/> <xsl:with-param name="fieldpos" select ="7"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTdate'"/> <xsl:with-param name="fieldpos" select ="8"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTpages'"/> <xsl:with-param name="fieldpos" select ="9"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTdescripElectroniq'"/> <xsl:with-param name="fieldpos" select ="10"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTcateg'"/> <xsl:with-param name="fieldpos" select ="11"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTmotsCles'"/> <xsl:with-param name="fieldpos" select ="12"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'ARTnotesSuppl'"/> <xsl:with-param name="fieldpos" select ="13"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'ARTajouterURLlivre'"/> <xsl:with-param name="fieldpos" select ="14"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'ARTsansGuillemet'"/> <xsl:with-param name="fieldpos" select ="15"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'ARTdateModif'"/> <xsl:with-param name="fieldpos" select ="16"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'LIVtypeDeRef'"/> <xsl:with-param name="fieldpos" select ="17"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVautNom'"/> <xsl:with-param name="fieldpos" select ="18"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVautPrenom'"/> <xsl:with-param name="fieldpos" select ="19"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVautSecond'"/> <xsl:with-param name="fieldpos" select ="20"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVtitre'"/> <xsl:with-param name="fieldpos" select ="21"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVvOLnum'"/> <xsl:with-param name="fieldpos" select ="22"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVvOLtitre'"/> <xsl:with-param name="fieldpos" select ="23"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVan1eParu'"/> <xsl:with-param name="fieldpos" select ="24"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVdescripElectroniq'"/> <xsl:with-param name="fieldpos" select ="25"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVdescripImprime'"/> <xsl:with-param name="fieldpos" select ="26"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVsupport'"/> <xsl:with-param name="fieldpos" select ="27"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDan'"/> <xsl:with-param name="fieldpos" select ="28"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDperiod'"/> <xsl:with-param name="fieldpos" select ="29"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDediteur'"/> <xsl:with-param name="fieldpos" select ="30"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDlieu'"/> <xsl:with-param name="fieldpos" select ="31"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDcoll'"/> <xsl:with-param name="fieldpos" select ="32"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVeDserie'"/> <xsl:with-param name="fieldpos" select ="33"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'LIVestPeriodiq'"/> <xsl:with-param name="fieldpos" select ="34"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVmentionDir'"/> <xsl:with-param name="fieldpos" select ="35"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVmentionEdit'"/> <xsl:with-param name="fieldpos" select ="36"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVtypeMemoire'"/> <xsl:with-param name="fieldpos" select ="37"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVnotesSupplem'"/> <xsl:with-param name="fieldpos" select ="38"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVcateg'"/> <xsl:with-param name="fieldpos" select ="39"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'LIVmotsCles'"/> <xsl:with-param name="fieldpos" select ="40"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'LIVobsPratiq'"/> <xsl:with-param name="fieldpos" select ="41"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'LIVdateModif'"/> <xsl:with-param name="fieldpos" select ="42"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'NOTEcitations'"/> <xsl:with-param name="fieldpos" select ="43"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'NOTEnotes'"/> <xsl:with-param name="fieldpos" select ="44"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'NOTEobsPratiq'"/> <xsl:with-param name="fieldpos" select ="45"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'NOTEdateModif'"/> <xsl:with-param name="fieldpos" select ="46"/></xsl:call-template>
		<xsl:call-template name="champ_filtre"><xsl:with-param name="tag" select ="'jeTeVeux'"/> <xsl:with-param name="fieldpos" select ="47"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'idnumlIV'"/> <xsl:with-param name="fieldpos" select ="48"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'idnumaRT'"/> <xsl:with-param name="fieldpos" select ="49"/></xsl:call-template>
		<xsl:call-template name="champ_brut"><xsl:with-param name="tag" select ="'idnumnOT'"/> <xsl:with-param name="fieldpos" select ="50"/></xsl:call-template>


		<!-- ferme balise de table -->
		<xsl:value-of select="$cr_only"/>
		<xsl:text>	</xsl:text>
		<xsl:call-template name="insertTag">
			<xsl:with-param name="tag" select ="$NDLtable"/> <xsl:with-param name="mustClose" select ="1"/>
		</xsl:call-template>

	</xsl:for-each>

	<xsl:value-of select="$cr_only"/>
	<xsl:call-template name="insertTag">
		<xsl:with-param name="tag" select ="'ndl'"/> <xsl:with-param name="mustClose" select ="1"/>
	</xsl:call-template>
	<xsl:value-of select="$cr_only"/>
</xsl:template>



<xsl:template name="champ_filtre">
			<xsl:param name="tag" />
			<xsl:param name="fieldpos" />
	<xsl:value-of select="$cr_indent" />
	<xsl:value-of select="concat('&lt;', $tag,'&gt;')" disable-output-escaping="yes" />
	<xsl:value-of select="normalize-space(fmp:COL[position()=$fieldpos])" />
	<xsl:value-of select="concat('&lt;/', $tag,'&gt;')" disable-output-escaping="yes" />
</xsl:template>

<xsl:template name="champ_brut">
			<xsl:param name="tag" />
			<xsl:param name="fieldpos" />
	<xsl:value-of select="$cr_indent" />
	<xsl:value-of select="concat('&lt;', $tag,'&gt;')" disable-output-escaping="yes" />
	<xsl:value-of select="fmp:COL[position()=$fieldpos]" />
	<xsl:value-of select="concat('&lt;/', $tag,'&gt;')" disable-output-escaping="yes" />
</xsl:template>

<xsl:template name="insertTag">
			<xsl:param name="tag" />
			<xsl:param name="mustClose" />
	<xsl:choose>
		<xsl:when test="$mustClose=1">
			<xsl:value-of select="concat('&lt;/', $tag,'&gt;')" disable-output-escaping="yes" />
		 </xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="concat('&lt;', $tag,'&gt;')" disable-output-escaping="yes" />
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>
<xsl:template name="openTagWithAttribute">
	<xsl:param name="tag" />
	<xsl:param name="attribName" />
	<xsl:param name="attribValue" />
		<xsl:variable name="tmp"> <xsl:value-of select="concat($attribName,'=&#34;', $attribValue,'&#34;')" /> </xsl:variable>
		<xsl:value-of select="concat('&lt;', $tag,' ', $tmp, '&gt;')" disable-output-escaping="yes" />
</xsl:template>


</xsl:stylesheet>